; Omnicalc v1.10
; (C) 2002-2003 Michael Vincent.
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
Hook_Parser:
	add a,e
	push af
	in a,(2)
	and 80h
	jp z,Hook_Parser_NotSE
	rlca
	out (20h),a
Hook_Parser_NotSE:
	pop af
	;now check for preparser or parser
	or a
	jp z,PreParser
	;dec a
	;jr nz,Hook_Parser_NotState
	xor a
	ld (parserHookPtr+3),a
	push hl
	ld hl,8A8Ah
	or a
	sbc hl,bc
	pop hl
	jp nz,Parse_NotReal
	ld a,l
	or a
	ret z
	dec a
	ret z
	;Now find which token and appropriate parser
	;HL is number of arguments
	push hl
	B_CALL PushRealO1		;Now we can jumble OP1 without losing an argument
	pop hl
	push hl
	ld d,h
	ld e,l
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	;HL now points to fps-HL
	push hl
	ex de,hl
	ld hl,(fps)
	or a
	sbc hl,de
	push hl
	;HL now if FPS where ## is
	rst 20h	;Store ## in OP1
	pop de	;DE to copy to.
	pop bc	;BC fps-HL, copy length
	ldir		;HL was setup by rst 20h
	ld hl,(fps)
	ld de,9
	or a
	sbc hl,de
	ld (fps),hl
	;Check to make sure we have a valid ##
	B_CALL CkPosInt
	jr z,Parser_Number_Ok
	pop hl
	B_JUMP ErrArgument
Parser_Number_Ok:
	B_CALL ConvOP1
	ld a,e
	cp 20
	jp c,Parser_Symbolic_Token
	sub 20
	ld e,a
	ld d,0
	ld hl,Parser_JumpTable
	sla e
	add hl,de
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	pop de
	ld a,e	;A = number of arguments
	dec a
	jp (hl)
	;FPS contains arguments from last to first
Parse_Sprite:
	;Arguments - (picture, source X pixel, source Y pixel, width, height, destination X, destination Y
	res 0,(iy+asm_Flag1)
	res 1,(iy+asm_Flag1)
	cp 7
	jr z,Parse_Sprite_NormalStart
	cp 8
	jp nz,Parse_Error_Argument
	B_CALL PopRealO1
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	B_CALL ConvOP1
	ld a,d
	or a
	jp nz,Parse_Error_Range
	ld (iy+asm_Flag1),e
Parse_Sprite_NormalStart:
	;Get destination Y
	B_CALL PopRealO1
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	B_CALL ConvOP1
	ld a,d
	or a
	jp nz,Parse_Error_Range
	ld a,e
	cp 64
	jp nc,Parse_Error_Range
	ld (spritedy),a
	;Get destination X
	B_CALL PopRealO1
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	B_CALL ConvOP1
	ld a,d
	or a
	jp nz,Parse_Error_Range
	ld a,e
	cp 96
	jp nc,Parse_Error_Range
	ld (spritedx),a
	;Get sprite height (pixels)
	B_CALL PopRealO1
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	B_CALL ConvOP1
	ld a,d
	or a
	jp nz,Parse_Error_Range
	ld a,e
	or a
	jp z,Parse_Error_Range
	cp 63
	jp nc,Parse_Error_Range
	ld (spriteheight),a
	;Get sprite width (pixels)
	B_CALL PopRealO1
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	B_CALL ConvOP1
	ld a,d
	or a
	jp nz,Parse_Error_Range
	ld a,e
	or a
	jp z,Parse_Error_Range
	cp 97
	jp nc,Parse_Error_Range
	ld (spritewidth),a
	sra a	;A/2
	jp c,Parse_Error_Range
	sra a	;A/4
	jp c,Parse_Error_Range
	sra a	;A/8
	jp c,Parse_Error_Range
	;We now know that the width MOD 8 = 0
	;Get sprite Y position (0-62)
	B_CALL PopRealO1
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	B_CALL ConvOP1
	ld a,d
	or a
	jp nz,Parse_Error_Range
	ld a,e
	cp 63
	jp nc,Parse_Error_Range
	ld (spritey),a
	ld b,a
	ld a,(spriteheight)
	add a,b
	cp 64
	jp nc,Parse_Error_Range
	;Get sprite X position (0-88 inclusive)
	B_CALL PopRealO1
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	B_CALL ConvOP1
	ld a,d
	or a
	jp nz,Parse_Error_Range
	ld a,e
	cp 96
	jp nc,Parse_Error_Range
	ld (spritex),a
	ld b,a
	ld a,(spritewidth)
	add a,b
	cp 97
	jp nc,Parse_Error_Range
	ld a,(spritex)
	sra a	;A/2
	jp c,Parse_Error_Range
	sra a ;A/4
	jp c,Parse_Error_Range
	sra a	;A/8
	jp c,Parse_Error_Range
	;Get picture
	B_CALL PopRealO1
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	B_CALL ConvOP1
	ld a,d
	or a
	jp nz,Parse_Error_Argument
	ld a,e
	cp 10
	jp nc,Parse_Error_Argument
	ld hl,Parse_Sprite_Table
	add hl,de
	ld a,(hl)
	ld hl,OP1
	ld (hl),PictObj
	inc hl
	ld (hl),tVarPict
	inc hl
	ld (hl),a
	inc hl
	ld (hl),0
	rst rFINDSYM
	jp c,Parse_Error_Argument
	;All is now go.
	ld a,(spritewidth)
	sra a
	sra a
	sra a
	;sprite width is in bytes
	ld b,a
	ld a,12
	sub b
	ld (dataskip),a	;how many bytes to skip across each row
	ex de,hl
	inc hl
	inc hl			;HL source data start
	ld a,(spritey)
	or a
	jr z,Parse_Sprite_SkipYAdd
	ld b,a
	ld de,12
Parse_Sprite_YAdd:
	add hl,de
	djnz Parse_Sprite_YAdd
Parse_Sprite_SkipYAdd:
	ld a,(spritewidth)
	sra a
	sra a
	sra a
	ld (spriteacross),a
	ld a,(spritex)
	sra a
	sra a
	sra a
	ld d,0
	ld e,a
	add hl,de
	;HL now points to first sprite data
	;DE to storage place
	ld de,Sprite_Data
	ld a,(spriteheight)
	ld b,a
Parse_Sprite_Loop:
	push bc
	ld a,(spriteacross)
	ld b,a
Parse_Sprite_Loop2:
	ld a,(hl)
	ld (de),a
	inc hl
	inc de
	djnz Parse_Sprite_Loop2
	ld a,(dataskip)
	ld b,0
	ld c,a
	add hl,bc
	pop bc
	djnz Parse_Sprite_Loop
	;(Sprite_Data) is start of sprite...
	B_CALL PDspGrph
	ld ix,Sprite_Data
	ld a,(spritewidth)
	sra a
	sra a
	sra a
	ld c,a
	ld a,(spriteheight)
	ld b,a
	ld a,(spritedy)
	ld l,a
	ld a,(spritedx)
	bit 1,(iy+asm_Flag1)	;reset (Z) if XOR, set (NZ) if OR
	jr nz,Parse_Sprite_ORLogic
	call largeSprite
Parse_Sprite_AfterRoutine:
	bit 0,(iy+asm_Flag1)
	jr nz,Parse_Sprite_NoCopyScreen
	B_CALL GrBufCpy
Parse_Sprite_NoCopyScreen:
	;Switch context
	;ld a,44h
	;MICHAEL_CALL 4030h
	set plotDisp,(iy+plotFlags)
	res graphDraw,(iy+graphFlags)
	B_CALL OP1Set0
	jp Parse_Token_ExitGood
Parse_Sprite_ORLogic:
	call largeSpriteOR
	jr Parse_Sprite_AfterRoutine
Parse_Sprite_Table:
	DB tPic0,tPic1,tPic2,tPic3
	DB tPic4,tPic5,tPic6,tPic7
	DB tPic8,tPic9
Parse_RomanDecimal:
	dec a
	jp nz,Parse_Error_Argument
	B_CALL PopRealO1
	ld a,(OP1)
	cp StrngObj
	jp nz,Parse_Error_DataType
	B_CALL ChkFindSym
	jp c,Parse_Error_Argument
	ex de,hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld a,b
	or c
	jp z,Parse_Error_Syntax
	push bc
	push hl
Parse_Roman_CheckValid:
	ld a,(hl)
	cp 'M'
	jr z,Parse_Roman_CheckValid_OK
	cp 'D'
	jr z,Parse_Roman_CheckValid_OK
	cp 'C'
	jr z,Parse_Roman_CheckValid_OK
	cp 'L'
	jr z,Parse_Roman_CheckValid_OK
	cp 'X'
	jr z,Parse_Roman_CheckValid_OK
	cp 'V'
	jr z,Parse_Roman_CheckValid_OK
	cp 'I'
	jr z,Parse_Roman_CheckValid_OK
	pop hl
	pop bc
	jp Parse_Error_Domain
Parse_Roman_CheckValid_OK:
	inc hl
	dec bc
	ld a,b
	or c
	jr nz,Parse_Roman_CheckValid
	pop hl
	pop bc
	ld ix,0
	;HL start of string, BC is length. IX is 0.
Parse_Roman:
	ld a,(hl)
	cp 'M'
	jr z,Parse_Roman_M
	cp 'D'
	jr z,Parse_Roman_D
	cp 'C'
	jr z,Parse_Roman_C
	cp 'L'
	jr z,Parse_Roman_L
	cp 'X'
	jr z,Parse_Roman_X
	cp 'V'
	jr z,Parse_Roman_V
	cp 'I'
	jr z,Parse_Roman_I
Parse_Roman_M:
	ld de,1000
	jr Parse_Roman_Ready
Parse_Roman_D:
	ld de,500
	jr Parse_Roman_Ready
Parse_Roman_C:
	ld de,100
	jr Parse_Roman_Ready
Parse_Roman_L:
	ld de,50
	jr Parse_Roman_Ready
Parse_Roman_X:
	ld de,10
	jr Parse_Roman_Ready
Parse_Roman_V:
	ld de,5
	jr Parse_Roman_Ready
Parse_Roman_I:
	ld de,1
Parse_Roman_Ready:
	push bc
	push hl
	ld hl,Parse_Roman_Table
	ld bc,-1
	cpir
	ld bc,Parse_Roman_Table
	or a
	sbc hl,bc
	ld a,l
	ld (offset),a
	pop hl
	push hl
	inc hl
	ld a,(hl)
	ld hl,Parse_Roman_Table
	ld bc,-1
	cpir
	ld bc,Parse_Roman_Table
	or a
	sbc hl,bc
	ld c,l
	ld a,(offset)
	inc c
	cp c
	jr c,Parse_Roman_Add
	pop hl
	pop bc
	ld (offset+2),bc
	ld (offset),hl
	push ix
	pop hl
	or a
	sbc hl,de
	push hl
	pop ix
	ld hl,(offset)
	ld bc,(offset+2)
	inc hl
	dec bc
	ld a,b
	or c
	jp nz,Parse_Roman
	jr Parse_Roman_Over
Parse_Roman_Add:
	pop hl
	pop bc
	add ix,de
	inc hl
	dec bc
	ld a,b
	or c
	jp nz,Parse_Roman
Parse_Roman_Over:
	push ix
	pop hl
	B_CALL SetXXXXOP2
	B_CALL OP2ToOP1
	jp Parse_Token_ExitGood
Parse_Roman_Table:
	DB "MDCLXVI"
Parse_RadicalSimplify:
	dec a
	jp nz,Parse_Error_Argument
	B_CALL PopRealO1
	B_CALL CkOP1Real
	jp nz,Parse_Error_DataType
	B_CALL CkPosInt
	jp nz,Parse_Error_Domain
	B_CALL CkOP1FP0
	jp z,Parse_Radical_Done
	B_CALL OP2Set1
	B_CALL CpOP1OP2
	jp z,Parse_Radical_Done
	;Ready to go!
	ld hl,OP1
	ld de,currentNum
	ld bc,9
	ldir
	B_CALL SqRoot
	B_CALL Trunc
	ld hl,OP1
	ld de,currentI
	ld bc,9
	ldir
	B_CALL OP4Set1
	ld hl,OP4
	ld de,currentCo
	ld bc,9
	ldir
Parse_Radical_Loop:
	in a,(4)
	bit 3,a
	jp z,Parse_Error_Break
	;check for end
	ld hl,currentI
	ld de,OP1
	ld bc,9
	ldir
	B_CALL OP2Set2
	B_CALL CpOP1OP2
	jp c,Parse_Radical_Over
	ld hl,currentI
	ld de,OP1
	ld bc,9
	ldir
	B_CALL FPSquare
	ld hl,OP1
	ld de,OP2
	ld bc,9
	ldir
	ld hl,currentNum	
	ld de,OP1
	ld bc,9
	ldir
	B_CALL FPDiv
	B_CALL CkPosInt
	jr nz,Parse_Radical_NoInt
	ld hl,OP1
	ld de,currentNum
	ld bc,9
	ldir
	ld hl,currentCo
	ld de,OP1
	ld bc,9
	ldir
	ld hl,currentI
	ld de,OP2
	ld bc,9
	ldir
	B_CALL FPMult
	ld hl,OP1
	ld de,currentCo
	ld bc,9
	ldir
	;optional below
	ld hl,currentNum
	ld de,OP1
	ld bc,9
	ldir
	B_CALL SqRoot
	ld hl,currentI
	ld de,OP2
	ld bc,9
	ldir
	B_CALL CpOP1OP2
	jr z,Parse_Radical_NoInt
	jr nc,Parse_Radical_NoInt
	B_CALL Trunc
	ld hl,OP1
	ld de,currentI
	ld bc,9
	ldir
	jp Parse_Radical_Loop
Parse_Radical_NoInt:
	ld hl,currentI
	ld de,OP1
	ld bc,9
	ldir
	B_CALL Minus1
	ld hl,OP1
	ld de,currentI
	ld bc,9
	ldir
	jp Parse_Radical_Loop
Parse_Radical_Over_Skip21:
	pop hl
	ld de,-2
	add hl,de
	push hl
	jr Parse_Radical_Over_Skip2
Parse_Radical_Over:
	;currentNum now is radicand
	;currentCo is the number in front of the radical sign
	ld hl,2
	push hl
	ld hl,currentCo
	ld de,OP1
	ld bc,9
	ldir
	B_CALL OP2Set1
	B_CALL CpOP1OP2
	jr z,Parse_Radical_Over_Skip1
	ld a,10
	B_CALL FormReal
	pop hl
	add hl,bc
	push hl
Parse_Radical_Over_Skip1:
	ld hl,currentNum
	ld de,OP1
	ld bc,9
	ldir
	B_CALL OP2Set1
	B_CALL CpOP1OP2
	jr z,Parse_Radical_Over_Skip21
	ld a,10
	B_CALL FormReal
	pop hl
	add hl,bc	;HL now contains total length
	push hl
Parse_Radical_Over_Skip2:
	B_CALL ZeroOP1
	ld a,StrngObj
	ld (OP1),a
	ld a,24h
	ld (OP1+1),a
	ld hl,(pTempCnt)
	inc hl
	ld (pTempCnt),hl
	dec hl
	ld ix,OP1
	ld (ix+2),l
	ld (ix+3),h
	ld hl,OP1
	ld de,tempop1
	ld bc,9
	ldir
	pop hl
	;HL is length
	B_CALL CreateStrng
	ex de,hl
	inc hl
	inc hl
Parse_Radical_Over_StringStart:
	;Ready to copy string
	push hl
	ld hl,currentCo
	ld de,OP1
	ld bc,9
	ldir
	B_CALL OP2Set1
	B_CALL CpOP1OP2
	jr z,Parse_Radical_Over_Skip3
	ld a,10
	B_CALL FormReal
	pop de
	ld hl,OP3
	ldir
Parse_Radical_Over_Skip4:
	push de
	ld hl,currentNum
	ld de,OP1
	ld bc,9
	ldir
	B_CALL OP2Set1
	B_CALL CpOP1OP2
	jp z,Parse_Radical_Over_Skip5
	pop de
	ld a,tSqrt
	ld (de),a
	inc de
	push de
	ld hl,currentNum
	ld de,OP1
	ld bc,9
	ldir
	ld a,10
	B_CALL FormReal
	pop de
	ld hl,OP3
	ldir
Parse_Radical_Over_Skip6:
	ld a,11h
	ld (de),a
	ld hl,tempop1
	ld de,OP1
	ld bc,9
	ldir
Parse_Radical_Done:
	xor a
	inc a
	ret
Parse_Radical_Over_Skip3:
	pop de
	jr Parse_Radical_Over_Skip4
Parse_Radical_Over_Skip5:
	pop de
	ld hl,tempop1
	ld de,OP1
	ld bc,9
	ldir
	jr Parse_Radical_Done
Parse_FactorNumber:
	dec a
	jp nz,Parse_Error_Argument
	B_CALL PopRealO1
	B_CALL CkOP1Real
	jp nz,Parse_Error_DataType
	B_CALL CkPosInt
	jp nz,Parse_Error_Domain
	ld hl,OP1
	ld de,currentNum2
	ld bc,9
	ldir
	ld hl,0
	ld (factorsCount),hl
	ld hl,2
	ld (primeptr),hl
Parse_Factor_Loop:
	in a,(4)
	bit 3,a
	jp z,Parse_Error_Break
	ld hl,currentNum2
	ld de,OP1
	ld bc,9
	ldir
	B_CALL SqRoot
	ld hl,(primeptr)
	B_CALL SetXXXXOP2
	B_CALL CpOP1OP2
	jp c,Parse_Factor_Over
	ld hl,(primeptr)
	B_CALL SetXXXXOP2
	ld hl,currentNum2
	ld de,OP1
	ld bc,9
	ldir
	B_CALL FPDiv
	B_CALL CkPosInt
	jr nz,Parse_Factor_NoInt
	ld hl,OP1
	ld de,currentNum2
	ld bc,9
	ldir
	ld hl,OP2
	ld de,OP1
	ld bc,9
	ldir
	B_CALL ConvOP1
	push de
	ld de,(factorsCount)
	ex de,hl
	add hl,hl
	ex de,hl
	ld hl,factorsList
	add hl,de
	pop de
	ld (hl),e
	inc hl
	ld (hl),d
	ld hl,(factorsCount)
	inc hl
	ld (factorsCount),hl
	ld hl,currentNum2
	ld de,OP1
	ld bc,9
	ldir
	B_CALL OP2Set1
	B_CALL CpOP1OP2
	jp z,Parse_Factor_Over
	jp Parse_Factor_Loop
Parse_Factor_NoInt:
	ld hl,(primeptr)
	ld de,2
	or a
	sbc hl,de
	jp z,Parse_Factor_Two
	add hl,de
	inc hl
	inc hl
	ld (primeptr),hl
	jp Parse_Factor_Loop
Parse_Factor_Two:
	ld hl,3
	ld (primeptr),hl
	jp Parse_Factor_Loop
Parse_Factor_Over:
	ld hl,currentNum2
	ld de,OP1
	ld bc,9
	ldir
	B_CALL ConvOP1
	push de
	ld de,(factorsCount)
	ex de,hl
	add hl,hl
	ex de,hl
	ld hl,factorsList
	add hl,de
	pop de
	ld (hl),e
	inc hl
	ld (hl),d
	ld hl,(factorsCount)
	inc hl
	ld (factorsCount),hl
	B_CALL ZeroOP1
	ld a,ListObj
	ld (OP1),a
	ld a,24h
	ld (OP1+1),a
	ld hl,(pTempCnt)
	inc hl
	ld (pTempCnt),hl
	dec hl
	ld ix,OP1
	ld (ix+2),l
	ld (ix+3),h
	ld hl,OP1
	ld de,86ECh
	ld bc,9
	ldir
	ld hl,(factorsCount)
	B_CALL CreateRList
	inc de
	inc de
	;DE is where to put data
	ld bc,(factorsCount)
	ld ix,factorsList
Parse_Factor_StoreLoop:
	push bc
	push de
	push ix
	ld l,(ix)
	ld h,(ix+1)
	B_CALL SetXXXXOP2
	pop ix
	pop de
	ld hl,OP2
	ld bc,9
	ldir
	inc ix
	inc ix
	pop bc
	dec bc
	ld a,b
	or c
	jr nz,Parse_Factor_StoreLoop
	ld hl,86ECh
	ld de,OP1
	ld bc,9
	ldir
	jp Parse_Token_ExitGood
Parse_Gamma:
	dec a
	jp nz,Parse_Error_Argument
	B_CALL PopRealO1
	B_CALL CkOP1Real
	jp nz,Parse_Error_DataType
	B_CALL LogGamma
	B_CALL TenX
	jp Parse_Token_ExitGood
Parse_Base:
	res convertbase,(iy+baseflags)
	cp 2
	jp z,Parse_Base_Start
	cp 3
	jp nz,Parse_Error_Argument
	B_CALL PopRealO1
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	B_CALL ConvOP1
	ld a,d
	or a
	jp nz,Parse_Error_Range
	ld a,e
	cp 37
	jp nc,Parse_Error_Range
	cp 2
	jp c,Parse_Error_Range
	;A is base
	set convertbase,(iy+baseflags)
	ld (newbase),a
Parse_Base_Start:
	B_CALL PopRealO1
	;Get base
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	B_CALL ConvOP1
	ld a,d
	or a
	jp nz,Parse_Error_Range
	ld a,e
	cp 37
	jp nc,Parse_Error_Range
	cp 2
	jp c,Parse_Error_Range
	;Bases 2-36 valid
	ld (numbase),a
	ld a,1
	ld (maxnum),a
	;Now build multiplication table
	ld ix,multtable+2
	ld (ix-2),1
	ld (ix-1),0
	ld hl,1
Parse_Base_BuildTable:
	ld a,(numbase)
	call MultiplyHLByA
	jr c,Parse_Base_BuildTable_Over
	ld (ix),l
	inc ix
	ld (ix),h
	inc ix
	ld a,(maxnum)
	inc a
	ld (maxnum),a
	jr Parse_Base_BuildTable
Parse_Base_BuildTable_Over:
	B_CALL PopRealO1
	;Get string
	ld a,(OP1)
	cp StrngObj
	jp nz,Parse_Error_DataType
	B_CALL ChkFindSym
	jp c,Parse_Error_Argument
	ld a,b
	or a
	jp nz,Parse_Error_Argument
	ex de,hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld a,b
	or c
	jp z,Parse_Error_Argument
	;HL data, BC size
	ld a,b
	or a
	jp nz,Parse_Error_Argument
	ld a,(maxnum)
	cp c
	jp c,Parse_Error_Range
	add hl,bc
	dec hl
	;HL is end of string, BC is length to work backwards
	ld de,0
	ld (partialans),de
	push hl
	pop ix
	ld de,multtable
	ld b,c
Parse_Base_Loop:
	push bc
	ld a,(ix)
	ld hl,Parse_Base_Table
	ld bc,36
	cpir
	jp nz,Parse_Error_Argument
	;Found a key
	ld bc,35
	add hl,bc
	ld c,(hl)
	;Now check C with our base to see if it is an invalid character
	ld a,(numbase)
	dec a
	cp c
	jp c,Parse_Error_DataType
	ld a,(de)
	ld l,a
	inc de
	ld a,(de)
	inc de
	ld h,a
	ld a,c
	;A * HL..DE is next place
	call MultiplyHLByA
	jp c,Parse_Error_Range
	ld bc,(partialans)
	add hl,bc
	ld (partialans),hl
	dec ix
	pop bc
	djnz Parse_Base_Loop
	ld hl,(partialans)
	B_CALL SetXXXXOP2
	B_CALL OP2ToOP1
	;OP1 here is decimal conversion
	bit convertbase,(iy+baseflags)
	jp z,Parse_Token_ExitGood
	ld hl,(partialans)
	call cxMain_BaseOutput_EntryPoint
	inc a
	ret
Parse_Base_Table:
	DB t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,tA,tB,tC,tD,tE,tF,tG,tH,tI,tJ,tK,tL,tM,tN
	DB tO,tP,tQ,tR,tS,tT,tU,tV,tW,tX,tY,tZ
	DB 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27
	DB 28,29,30,31,32,33,34,35
MultiplyHLByA:
	or a
	jr z,MultiplyHLByA_Zero
	ld b,h
	ld c,l
	dec a
	ret z
MultiplyHLByA_Loop:
	add hl,bc
	ret c
	dec a
	jr nz,MultiplyHLByA_Loop
	ret
MultiplyHLByA_Zero:
	ld hl,0
	ret
Parse_LinkGet:
	dec a
	jp nz,Parse_Error_Argument
	B_CALL PopRealO1
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	B_CALL ConvOP1
	or a
	jr z,Parse_LinkGet_NoWait
	in a,(2)
	and 80h
	jr z,Parse_LinkGet_Regular
Parse_LinkGet_SE:
	in a,(4)
	bit 3,a
	jp z,Parse_Error_Break
	in a,(9)
	bit 4,a
	jr z,Parse_LinkGet_SE
	jr Parse_LinkGet_ByteExit
Parse_LinkGet_Regular:
	in a,(4)
	bit 3,a
	jp z,Parse_Error_Break
	in a,(0)
	and 3
	cp 3
	jr z,Parse_LinkGet_Regular
Parse_LinkGet_ByteExit:
	B_CALL RecAByteIO
	ld h,0
	ld l,a
	B_CALL SetXXXXOP2
	B_CALL OP2ToOP1
	jp Parse_Token_ExitGood
Parse_LinkGet_NoWait:
	in a,(2)
	and 80h
	jr nz,Parse_LinkGet_NoWaitSE
	in a,(0)
	and 3
	cp 3
	jr z,Parse_LinkGet_ReturnBad
	jr Parse_LinkGet_ByteExit
Parse_LinkGet_NoWaitSE:
	in a,(9)
	bit 4,a
	jr z,Parse_LinkGet_ReturnBad
	jr Parse_LinkGet_ByteExit
Parse_LinkGet_ReturnBad:
	ld hl,Parse_Negative1
	rst 20h
	jp Parse_Token_ExitGood
Parse_LinkSend:
	dec a
	jp nz,Parse_Error_Argument
	B_CALL PopRealO1
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	B_CALL ConvOP1
	ld a,d
	or a
	jp nz,Parse_Error_Range
	ld a,e
	AppOnErr Parse_LinkSend_Err
	B_CALL SendAByte
	AppOffErr
	B_CALL OP1Set0
	jp Parse_Token_ExitGood
Parse_LinkSend_Err:
	ld hl,Parse_Negative1
	rst 20h
	jp Parse_Token_ExitGood
Parse_Modulo:
	cp 2
	jp nz,Parse_Error_Argument
	B_CALL PopRealO2
	ld a,(OP2)
	or a
	jp nz,Parse_Error_DataType
	B_CALL PopRealO1
	ld a,(OP1)
	or a
	jp nz,Parse_Error_DataType
	rst rpushrealo1
	B_CALL PushRealO2
	B_CALL FPDiv
	B_CALL Trunc
	B_CALL PopRealO2
	B_CALL FPMult
	B_CALL OP1ToOP2
	B_CALL PopRealO1
	B_CALL FPSub
	jp Parse_Token_ExitGood
Parse_Constant:
	dec a
	jp nz,Parse_Error_Argument
	B_CALL PopRealO1
	ld a,(OP1)
	cp StrngObj
	jp nz,Parse_Error_Argument
	B_CALL ChkFindSym
	jp c,Parse_Error_Undefined
	ld hl,Parse_Constant_Table
Parse_Constant_CheckLoop:
	push de
	ld c,(hl)
	inc hl
	ld b,(hl)
	dec hl
	inc bc
	ld a,b
	or c
	jp z,Parse_Error_Argument
	inc bc
Parse_Constant_CheckLoop2:
	ld a,(de)
	cp (hl)
	jr nz,Parse_Constant_CheckLoop2_Failed
	inc hl
	inc de
	dec bc
	ld a,b
	or c
	jr nz,Parse_Constant_CheckLoop2
	;Found match...
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	;ld a,h
	;or l
	;jr z,Parse_Constant_SaveTheManatees
	rst 20h
	pop de
	xor a
	inc a
	ret
Parse_Constant_CheckLoop2_Failed:
	add hl,bc
	inc hl
	inc hl
	pop de
	jr Parse_Constant_CheckLoop
;Parse_Constant_SaveTheManatees:
	;*cough* :)
;	call GetRealSettings
;	bit 7,(hl)
;	jr z,Parse_Constant_SaveTheManatees_Skip
;	ld hl,Manatee_Hook
;	in a,(6)
;	B_CALL SetCursorHook
;	xor a
;	ld (manateebyte),a
;Parse_Constant_SaveTheManatees_Skip:
;	B_CALL OP1Set0
;	pop de
;	xor a
;	inc a
;	ret
Parse_Constant_Table:
	DW 2
	DB "NA"
	DW Parse_Constant_Na
	DW 1
	DB "K"
	DW Parse_Constant_k
	DW 2
	DB "CC"
	DW Parse_Constant_Cc
	DW 2
	DB "EC"
	DW Parse_Constant_ec
	DW 2
	DB "RC"
	DW Parse_Constant_Rc
	DW 2
	DB "GC"
	DW Parse_Constant_Gc
	DW 1
	DB "G"
	DW Parse_Constant_g
	DW 2
	DB "ME"
	DW Parse_Constant_Me
	DW 2
	DB "MP"
	DW Parse_Constant_Mp
	DW 2
	DB "MN"
	DW Parse_Constant_Mn
	DW 1
	DB "H"
	DW Parse_Constant_h
	DW 1
	DB "C"
	DW Parse_Constant_c
	DW 1
	DB "U"
	DW Parse_Constant_u
	;DW 25
	;DB "I",tSpace,"SHALL",tSpace,"SAVE",tSpace,"THE",tSpace,"MANATEES"
	;DW 0
	DW 0FFFFh
Parse_Constant_Na:
	DB 00h,97h,60h,22h,13h,67h,00h,00h,00h
Parse_Constant_k:
	DB 00h,69h,13h,80h,65h,80h,00h,00h,00h
Parse_Constant_Cc:
	DB 00h,89h,89h,87h,55h,17h,87h,37h,00h
Parse_Constant_ec:
	DB 00h,6Dh,16h,02h,17h,73h,30h,00h,00h
Parse_Constant_Rc:
	DB 00h,80h,83h,14h,51h,00h,00h,00h,00h
Parse_Constant_Gc:
	DB 00h,75h,66h,72h,59h,00h,00h,00h,00h
Parse_Constant_g:
	DB 00h,80h,98h,06h,65h,00h,00h,00h,00h
Parse_Constant_Me:
	DB 00h,61h,91h,09h,38h,97h,00h,00h,00h
Parse_Constant_Mp:
	DB 00h,65h,16h,72h,62h,31h,00h,00h,00h
Parse_Constant_Mn:
	DB 00h,65h,16h,74h,92h,86h,00h,00h,00h
Parse_Constant_h:
	DB 00h,5Eh,66h,26h,07h,55h,00h,00h,00h
Parse_Constant_c:
	DB 00h,88h,29h,97h,92h,45h,80h,00h,00h
Parse_Constant_u:
	DB 00h,65h,16h,60h,54h,02h,00h,00h,00h
Parse_Subfactorial:
	dec a
	jp nz,Parse_Error_Argument
	B_CALL PopRealO1
	B_CALL CkPosInt
	jp nz,Parse_Error_DataType
	;OP1 is N
	ld de,nvariable
	B_CALL MovFrOP1
	B_CALL OP1Set0
	ld de,kvariable
	B_CALL MovFrOP1
	ld de,summation
	B_CALL MovFrOP1
Parse_Subfactorial_Loop:
	;Loop is set up...
	ld hl,Parse_Negative1
	rst 20h
	ld hl,kvariable
	ld de,OP2
	ld bc,9
	ldir
	B_CALL YToX
	;OP1 now has numerator of summation fraction
	B_CALL OP1ToOP5
	;OP5 is numerator
	ld hl,kvariable
	rst 20h
	B_CALL Factorial
	;OP1 is denominator
	B_CALL OP1ToOP2
	B_CALL OP5ToOP1
	B_CALL FPDiv
	;summation evaluation complete
	;OP1 is answer...
	ld hl,summation
	ld de,OP2
	ld bc,9
	ldir
	B_CALL FPAdd
	ld de,summation
	B_CALL MovFrOP1
	ld hl,kvariable
	rst 20h
	;OP1 = K
	B_CALL Plus1
	ld de,kvariable
	B_CALL MovFrOP1
	ld hl,nvariable
	ld de,OP2
	ld bc,9
	ldir
	B_CALL CpOP1OP2
	jr z,Parse_Subfactorial_Loop
	jr c,Parse_Subfactorial_Loop
	B_CALL OP2ToOP1
	B_CALL Factorial
	ld hl,summation
	ld de,OP2
	ld bc,9
	ldir
	B_CALL FPMult
	jp Parse_Token_ExitGood
Parse_Program:
	dec a
	jp nz,Parse_Error_Argument
	B_CALL PopRealO1
	B_CALL OP1Set0
	jp Parse_Token_ExitGood
Parse_RestoreMemory:
	dec a
	jp nz,Parse_Error_Argument
	B_CALL PopRealO1
	in a,(2)
	and 80h
	jp z,Parse_Error_Range
	ld a,1
	out (20h),a
	di
	;Now check for corruption.
	ld a,86h
	out (7),a
	ld hl,cxMain_BackupRAM_Checksum
	ld de,8000h
	ld b,16
	call CompareStrings
	ld a,81h
	out (7),a
	jp nz,Parse_Error_DataType
	ld a,86h
	out (7),a
	ld hl,(8050h)
	push hl
	ld a,87h
	out (7),a
	ld hl,8000h
	ld bc,4000h
	ld ix,0
Parse_RestoreMemory_Checksum:
	ld e,(hl)
	ld d,0
	add ix,de
	inc hl
	dec bc
	ld a,b
	or c
	jr nz,Parse_RestoreMemory_Checksum
	push ix
	pop de
	pop hl
	ld a,81h
	out (7),a
	or a
	sbc hl,de
	jp nz,Parse_Error_DataType
	;we are go
	di
	ld a,87h
	out (7),a
	ld hl,8000h
	ld de,0C000h
	ld bc,4000h
	ldir
	;Now for lower page
	ld hl,8000h
	ld bc,4000h
Parse_RestoreRAM_SwapLoop:
	ld a,86h
	out (7),a
	ld e,(hl)
	ld a,81h
	out (7),a
	ld (hl),e
	inc hl
	dec bc
	ld a,b
	or c
	jr nz,Parse_RestoreRAM_SwapLoop
	;All done...with the RAM part.
	;ld hl,9872h
	;call CopyLayer
	ld sp,(86ECh)
	ret
Parse_Negative1:
	DB 80h,80h,10h,00h,00h,00h,00h,00h,00h
Parse_Token_ExitGood:
	xor a
	inc a
	ret
Parse_NotReal:
	xor a
	ret
Hook_Parser_NotState:
	cp a
	ret
Parser_JumpTable:
	DW Parse_Sprite
	DW Parse_RomanDecimal
	DW Parse_RadicalSimplify
	DW Parse_FactorNumber
	DW Parse_Gamma
	DW Parse_Base
	DW Parse_LinkGet
	DW Parse_LinkSend
	DW Parse_Modulo
	DW Parse_Constant
	DW Parse_Subfactorial
	DW Parse_Program
	DW Parse_RestoreMemory
Parse_Error_Range:
	B_JUMP ErrDomain
Parse_Error_DataType:
	B_JUMP ErrDataType
Parse_Error_Domain:
	B_JUMP ErrDomain
Parse_Error_Break:
	B_JUMP ErrBreak
Parse_Error_Syntax:
	B_JUMP ErrSyntax
Parse_Error_Argument:
	B_JUMP ErrArgument
Parse_Error_Undefined:
	B_JUMP ErrUndefined
PreParser:
	ld a,(parserHookPtr+3)
	dec a
	jp z,PreParser_Recursive
	;OP1 is variable being parsed
	;We must change all tokens CFh and above to real(token-CF,arguments)
	ld hl,OP1
	ld de,op1backup
	ld bc,9
	ldir
	B_CALL ChkFindSym
	jp c,Hook_Parser_NotState
	xor a
	ld (parserHookPtr+3),a
	ex de,hl
	ld (sizebytes),hl
	ld c,(hl)
	inc hl
	ld b,(hl)	;Get size
	ld a,b
	or c
	ret z
	inc hl
	push hl
	add hl,bc
	ld (bufferend),hl
	pop hl
	;(bufferend)-1 is last token
	ld bc,0
	ld (sizechange),bc
	res inQuotes,(iy+parseFlags)
PreParser_Replace_Loop:
	ld a,(hl)
	cp tString
	call z,PreParser_QuoteFound
	cp tEnter
	call z,PreParser_ResetQuote
	bit inQuotes,(iy+parseFlags)
	jr nz,PreParser_Replace_NextToken
	cp 0BBh
	jr nz,PreParser_Replace_NextToken
	inc hl
	ld a,(hl)
	cp 0CFh
	jr c,PreParser_Replace_NextToken
	ld (hl),tReal
	push af
	;We found a BB,CF or greater token...
	inc hl
	ex de,hl
	;DE = insertion address
	ld hl,3
	B_CALL InsertMem
	ld bc,(sizechange)
	inc bc
	inc bc
	inc bc
	ld (sizechange),bc
	ld bc,(bufferend)
	inc bc
	inc bc
	inc bc
	ld (bufferend),bc
	ex de,hl
	;HL now points to 3 bytes to store the "##,"
	pop af
	sub 0CFh
	ld c,-1
PreParser_Get10:
	inc c
	sub 10
	jr nc,PreParser_Get10
	add a,10
	;C is number of 10s, A is remainder
	push af
	ld a,t0
	add a,c
	ld (hl),a
	pop af
	;Now second number
	inc hl
	add a,t0
	ld (hl),a
	;Comma time
	inc hl
	ld (hl),tComma
	;Done...Continue for more tokens
	ld a,1
	ld (parserHookPtr+3),a
PreParser_Replace_NextToken:
	inc hl
	push hl
	ld de,(bufferend)
	or a
	sbc hl,de
	pop hl
	jr nz,PreParser_Replace_Loop
	;Update size bytes now
	ld hl,(sizebytes)
	ld c,(hl)
	inc hl
	ld b,(hl)
	push hl
	ld hl,(sizechange)
	add hl,bc
	ex hl,de
	pop hl
	ld (hl),d
	dec hl
	ld (hl),e
	ld a,(parserHookPtr+3)
	or a
	ret z
	B_CALL PushRealO1
	AppOnErr ParsingErrorOccured
	B_CALL ParseInp
	AppOffErr
	;Change real(##,arguments) to token(arguments)
	call PreParser_Restore
	xor a
	inc a
	ret
PreParser_QuoteFound:
	;Toggle flag
	push af
	ld a,(iy+parseFlags)
	xor 00000001b
	ld (iy+parseFlags),a
	pop af
	ret
PreParser_ResetQuote:
	res inQuotes,(iy+parseFlags)
	ret
ParsingErrorOccured:
	push af
	call PreParser_Restore
	pop af
	B_JUMP JError
PreParser_Recursive:
	xor a
	ld (parserHookPtr+3),a
	ret
PreParser_Restore:
	ld hl,OP1
	ld de,op1backup2
	ld bc,9
	ldir
	B_CALL PopRealO1
	B_CALL ChkFindSym
	ex de,hl
	ld (sizebytes),hl
	ld c,(hl)
	inc hl
	ld b,(hl)	;Get size
	inc hl
	push hl
	add hl,bc
	ld (bufferend),hl
	pop hl
	;(bufferend)-1 is last token
	ld bc,0
	ld (sizechange),bc
PreParser_Restore_Loop:
	ld a,(hl)
	cp 0BBh
	jr nz,PreParser_Restore_NextToken
	inc hl
	ld a,(hl)
	cp tReal
	jr nz,PreParser_Restore_NextToken
	;We found a Real token
	;Now check if it has "##," after it.
	inc hl
	ld a,(hl)
	cp t0
	jr c,PreParser_Restore_NextToken
	cp t9+1
	jr nc,PreParser_Restore_NextToken
	;Next # check
	inc hl
	ld a,(hl)
	cp t0
	jr c,PreParser_Restore_NextToken
	cp t9+1
	jr nc,PreParser_Restore_NextToken
	inc hl
	ld a,(hl)
	cp tComma
	jr nz,PreParser_Restore_NextToken
	;We have a real(##,arguments)
	dec hl
	dec hl
	ld a,(hl)
	sub t0
	or a
	jr z,PreParser_Restore_Add10_Skip
	ld b,a
	xor a
PreParser_Restore_Add10:
	add a,10
	djnz PreParser_Restore_Add10
PreParser_Restore_Add10_Skip:
	inc hl
	ld c,a
	ld a,(hl)
	sub t0
	add a,c
	dec hl
	ld (oldtoken),a
	ld de,3
	push hl
	B_CALL DelMem
	pop hl
	dec hl
	ld a,(oldtoken)
	add a,0CFh
	ld (hl),a
	ld bc,(sizechange)
	dec bc
	dec bc
	dec bc
	ld (sizechange),bc
	ld bc,(bufferend)
	dec bc
	dec bc
	dec bc
	ld (bufferend),bc
	;Done...Continue for more tokens
PreParser_Restore_NextToken:
	inc hl
	push hl
	ld de,(bufferend)
	or a
	sbc hl,de
	pop hl
	jr c,PreParser_Restore_Loop
	;Update size bytes now
	ld hl,(sizebytes)
	ld c,(hl)
	inc hl
	ld b,(hl)
	push hl
	ld hl,(sizechange)
	add hl,bc
	ex hl,de
	pop hl
	ld (hl),d
	dec hl
	ld (hl),e
	ld hl,op1backup2
	rst 20h
	ret
Parse_Exit:
	pop hl
Parse_Exit2:
	xor a
	ret
;---------= Large Sprite =---------
; Draws a Large sprite.
;Input:	ix->sprite
;	a=x
;	l=y
;	b=height	(in pixels)
;	c=width		(in bytes, e.g. 2 would be 16)
;Output: nothing
; All registers are destroyed except bc', de', hl'
;
largeSprite:
	di
	ex af,af'
	ld a,c
	push af
	ex af,af'
	ld e,l
	ld h,0
	ld d,h
	add hl,de
	add hl,de
	add hl,hl
	add hl,hl
	ld e,a
	and 07h
	ld c,a
	srl e
	srl e
	srl e
	add hl,de
	ld de,plotsscreen
	add hl,de
lsl0:
 push hl
lsl1:
	ld d,(ix)
	ld e,0
	ld a,c
	or a
	jr z,lsl3
lsl2:
	srl d
	rr e
	dec a
	jr nz,lsl2
lsl3:
	ld a,(hl)
	xor d
	ld (hl),a
	inc hl
	ld a,(hl)
	xor e
	ld (hl),a
	inc ix
	ex af,af'
	dec a
	push af
	ex af,af'
	pop af
	jr nz,lsl1
	pop hl
	pop af
	push af
	ex af,af'
	ld de,0Ch
	add hl,de
	djnz lsl0
	pop af
	ei
	ret
	;---------= Large Sprite =---------
; Draws a Large sprite.
;Input:	ix->sprite
;	a=x
;	l=y
;	b=height	(in pixels)
;	c=width		(in bytes, e.g. 2 would be 16)
;Output: nothing
; All registers are destroyed except bc', de', hl'
;
largeSpriteOR:
	di
	ex af,af'
	ld a,c
	push af
	ex af,af'
	ld e,l
	ld h,0
	ld d,h
	add hl,de
	add hl,de
	add hl,hl
	add hl,hl
	ld e,a
	and 07h
	ld c,a
	srl e
	srl e
	srl e
	add hl,de
	ld de,plotsscreen
	add hl,de
lsl0OR:
 push hl
lsl1OR:
	ld d,(ix)
	ld e,0
	ld a,c
	or a
	jr z,lsl3OR
lsl2OR:
	srl d
	rr e
	dec a
	jr nz,lsl2OR
lsl3OR:
	ld a,(hl)
	or d
	ld (hl),a
	inc hl
	ld a,(hl)
	or e
	ld (hl),a
	inc ix
	ex af,af'
	dec a
	push af
	ex af,af'
	pop af
	jr nz,lsl1OR
	pop hl
	pop af
	push af
	ex af,af'
	ld de,0Ch
	add hl,de
	djnz lsl0OR
	pop af
	ei
	ret
Parser_Symbolic_Token:
	push af
	ld hl,SymbolicApp
	rst 20h
	B_CALL FindApp
	jr c,Parser_Symbolic_Token_NotFound
	ld b,a
	pop af
	ld c,a
	push bc
	ld hl,Parser_Symbolic_Jumper
	ld de,9872h
	ld bc,Parser_Symbolic_Jumper_End-Parser_Symbolic_Jumper
	ldir
	pop bc
	jp 9872h
Parser_Symbolic_Token_NotFound:
	pop af
	jp Parse_Error_Undefined
Parser_Symbolic_Jumper:
	;B is symbolic's ROM page
	;C is token value
	ld a,b
	out (6),a
	ld hl,4082h
	ld d,0
	ld e,c
	sla e
	add hl,de
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	;HL is where to jump to...
	in a,(2)
	and 80h
	jr nz,Parser_Symbolic_Jumper_SE
	jp (hl)
Parser_Symbolic_Jumper_SE:
	xor a
	out (20h),a
	jp (hl)
Parser_Symbolic_Jumper_End:
